> ## Documentation Index
> Fetch the complete documentation index at: https://docs.usefini.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create library criterion

> Save a new custom criterion to the workspace library.

Save a new custom criterion to the workspace library.

This route does not accept `defaultCriterionId`. For type-specific validation and condition shape, see [Criterion definitions](/en/api-reference/test-suite#criterion-definitions).

## Headers

<ParamField header="Authorization" type="string" required>
  Bearer token containing your workspace API key. The key needs `write` scope.
</ParamField>

## Body parameters

<ParamField body="name" type="string" required>
  Nonblank criterion name.
</ParamField>

<ParamField body="type" type="enum" required>
  `deterministic`, `basic_judge` or `complex_judge`.
</ParamField>

<ParamField body="condition" type="object">
  Required for deterministic criteria. Must be absent or null for judge criteria.
</ParamField>

<ParamField body="judgePrompt" type="string">
  Required nonblank judge instructions for either judge type.
</ParamField>

<ParamField body="passPrompt" type="string">
  Required nonblank pass definition for either judge type.
</ParamField>

<ParamField body="failPrompt" type="string">
  Required nonblank fail definition for either judge type.
</ParamField>

<ParamField body="blocking" type="boolean">
  Whether failure makes the case fail. Defaults to true for new custom criteria.
</ParamField>

## Response

Returns the saved criterion definition.

<RequestExample>
  ```bash cURL theme={null}
  curl --request POST \
    --url 'https://api-prod.usefini.com/v2/test-suite/criteria/public' \
    --header 'Authorization: Bearer fini_your_api_key' \
    --header 'Content-Type: application/json' \
    --data '{
    "name": "No handoff",
    "type": "deterministic",
    "condition": {
      "scope": "SCALAR",
      "predicate": {
        "left": {
          "path": "escalated",
          "dataType": "boolean"
        },
        "operator": "==",
        "right": {
          "value": false
        }
      }
    },
    "blocking": true
  }'
  ```

  ```javascript Node.js theme={null}
  const body = {
    "name": "No handoff",
    "type": "deterministic",
    "condition": {
      "scope": "SCALAR",
      "predicate": {
        "left": {
          "path": "escalated",
          "dataType": "boolean"
        },
        "operator": "==",
        "right": {
          "value": false
        }
      }
    },
    "blocking": true
  };

  const response = await fetch("https://api-prod.usefini.com/v2/test-suite/criteria/public", {
    method: "POST",
    headers: {
      Authorization: "Bearer fini_your_api_key",
      "Content-Type": "application/json",
    },
    body: JSON.stringify(body),
  });
  if (!response.ok) throw new Error(await response.text());
  const result = await response.json();
  ```

  ```python Python theme={null}
  import requests
  import json

  body = json.loads('''
  {
    "name": "No handoff",
    "type": "deterministic",
    "condition": {
      "scope": "SCALAR",
      "predicate": {
        "left": {
          "path": "escalated",
          "dataType": "boolean"
        },
        "operator": "==",
        "right": {
          "value": false
        }
      }
    },
    "blocking": true
  }
  ''')

  response = requests.request(
      "POST",
      "https://api-prod.usefini.com/v2/test-suite/criteria/public",
      headers={"Authorization": "Bearer fini_your_api_key"},
      json=body,
  )
  response.raise_for_status()
  result = response.json()
  ```
</RequestExample>

<ResponseExample>
  ```json 201 Created theme={null}
  {
    "id": "00000000-0000-4000-8000-000000000012",
    "companyId": "00000000-0000-4000-8000-000000000011",
    "defaultCriterionId": null,
    "name": "No handoff",
    "type": "deterministic",
    "condition": {
      "scope": "SCALAR",
      "predicate": {"left": {"path": "escalated", "dataType": "boolean"}, "operator": "==", "right": {"value": false}}
    },
    "blocking": true,
    "judgePrompt": null,
    "passPrompt": null,
    "failPrompt": null,
    "isActive": true,
    "createdAt": "2026-10-12T10:00:00.000Z",
    "updatedAt": "2026-10-12T10:00:00.000Z"
  }
  ```
</ResponseExample>


## Related topics

- [Overview](/en/api-reference/test-suite.md)
- [API overview](/en/api-reference/overview.md)
- [Create test case](/en/api-reference/create-test-suite-case.md)


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.